"""Shared choices for the different models."""

from enum import StrEnum

from pydantic_forms.types import strEnum


class Vendor(strEnum):
    """Enumerator for the different product vendors that are supported."""

    JUNIPER = "juniper"
    NOKIA = "nokia"


class ConnectionStrategy(strEnum):
    """An enumerator for the connection Strategies."""

    IN_BAND = "IN BAND"
    OUT_OF_BAND = "OUT OF BAND"


class SNMPVersion(StrEnum):
    """An enumerator for the two relevant versions of :term:`SNMP`: v2c and 3."""

    V2C = "v2c"
    V3 = "v3"


class APType(strEnum):
    """Enumerator of the types of Access Port."""

    PRIMARY = "PRIMARY"
    BACKUP = "BACKUP"
    LOAD_BALANCED = "LOAD_BALANCED"


class SBPType(strEnum):
    """Enumerator for the two allowed types of service binding port: layer 2 or layer 3."""

    L2 = "l2"
    L3 = "l3"
